import java.sql.*;
import java.util.*;
import java.io.*;
import java.math.*;
import org.apache.derbyTesting.functionTests.util.Formatters;

/**
 */

public class Repro
{
	private static java.sql.Connection conn = null;
	public static String conntype;




	public static void main(String[] args)
	{
		conntype = null;
		// assume connecting to cloudscape via jcc
		if (args.length < 1)			
			conntype = "derby";
		else 
			conntype = args[0].toLowerCase();

		try
		{
			conn = initConn(conntype,"mall.10");
			System.out.println("conn.toString():" + conn);
			if (conn == null)
				System.exit(-1);
			test(conn);
		}
		catch (Exception e)
		{
			errorPrint(e);
		}
	}



	static void test(Connection conn) throws Exception
	{
		conn.setAutoCommit(false);
		PreparedStatement ps = null;
		String sql ="ALTER TABLE shparrange ADD COLUMN optcounter SMALLINT";		
		ps = conn.prepareStatement(sql);
		ps.executeUpdate();
		
	}
	
		
		
	static void errorPrint(Throwable e) {
		if (e instanceof SQLException) 
			SQLExceptionPrint((SQLException)e);
		else
			System.out.println("A non SQL error occured.");
		e.printStackTrace();
	}

	static void SQLExceptionPrint(SQLException sqle) {
		while (sqle != null) {
			System.out.println("\n---SQLException Caught---\n");
			System.out.println("SQLState:   " + (sqle).getSQLState());
			System.out.println("Severity: " + (sqle).getErrorCode());
			System.out.println("Message:  " + (sqle).getMessage()); 
			sqle.printStackTrace();  
			sqle = sqle.getNextException();
		}
	}  /* END SQLExceptionPrint   */


	public static Connection initConn(String conntype) throws Exception
	{
		return initConn(conntype, null);
	}
	public static  Connection initConn(String conntype, String dbname) throws Exception
	{
		Connection connection = null;
		String driver = null;
		String url = null;

		if (dbname == null)
			dbname = "WOMBAT";
		//DssTrace.startComBufferTrace(new PrintWriter(new FileOutputStream("atestMetaData.trc")));
		if (conntype.equals("db2app"))
		{
				driver = "COM.ibm.db2.jdbc.app.DB2Driver";
				url = "jdbc:db2:wombatc";
		}
		else if (conntype.equals("db2jcc"))
		{
				driver = "com.ibm.db2.jcc.DB2Driver";
				url = "jdbc:db2://localhost:50000/wombat:retrieveMessagesFromServerOnGetMessage=true;";
		}
		else if (conntype.equals("csnet"))
		{
			driver = "com.ibm.db2.jcc.DB2Driver";
			url =  "jdbc:cloudscape:net://localhost:1527/" + dbname +";create=true:retrieveMessagesFromServerOnGetMessage=true;";
		}
		else if (conntype.equals("cs"))
		{
			driver = "com.ihost.cs.jdbc.CloudscapeDriver";
			url =  "jdbc:cloudscape:" + dbname + ";create=true";
		}
		else if (conntype.equals("db2jnet"))
		{
			driver = "com.ibm.db2.jcc.DB2Driver";
			url =  "jdbc:db2j:net://localhost:1527/" + dbname +";create=true:retrieveMessagesFromServerOnGetMessage=true;";
		}
		else if (conntype.equals("db2j"))
		{
			dbname = "bpedb";
			driver = "com.ibm.db2j.jdbc.DB2jDriver";
			url =  "jdbc:db2j:" + dbname + ";create=true";
		}
		else if (conntype.equals("derby"))
		{
			driver = "org.apache.derby.jdbc.EmbeddedDriver";
			url =  "jdbc:derby:" + dbname + ";create=true";
		}
		else if (conntype.equals("derbynet"))
		{
			driver = "com.ibm.db2.jcc.DB2Driver";
			url =  "jdbc:derby:net://localhost:1527/" + dbname +";create=true:retrieveMessagesFromServerOnGetMessage=true;";
		}
		else if (conntype.equals("derbynetclient"))
		{
			driver = "org.apache.derby.jdbc.ClientDriver";
			url = "jdbc:derby://localhost:1527/" + dbname + ";create=true";
		}
		else 
		{
			System.err.println("Invalid connection type: " + conntype);
			System.err.println("Usage: java " + "Template" +  " [DB2jcc | DB2app | db2j | db2jNet | csNet | cs | derby | derbyNet | derbyNetClient]");
			return null;
		}

		System.out.println("Initializing connection type: " + conntype);
		System.out.println("driver: " + driver);
		System.out.println("url: " + url);

		// Initialize Driver. and set up tracing
		PrintStream trace =null;
		try {
			trace = new PrintStream(new FileOutputStream("trace.out"));
		} catch (IOException ioe) {
			System.err.println ("IO Exception : " + ioe.getMessage());
		}
		
		Driver driverClass = (Driver) Class.forName(driver).newInstance();
		java.sql.DriverManager.setLogStream(trace);

		//start trace
		System.out.println("Obtaining the connection");
		connection = DriverManager.getConnection(url,
								 "APP","xxxx");

		

		DatabaseMetaData met = connection.getMetaData();
		System.out.println("Product Name: " + met.getDatabaseProductName());
		return connection;
		
	}
    
	

}




